#include <stdio.h>
#include <stdlib.h>
#include <math.h>

FILE *main_inp;
FILE *main_inp2;
FILE *main_out;

#define MAX_R 200000
#define MAXD 500
#define NTOT 244 /* number of atoms being looked */

int main(void)
{
    int i,j,m,status,skip,tempd,nvert,nvert2[MAX_R],vert[MAX_R];
    int tempd2;
    double temp,x[MAX_R],y[MAX_R],area;

    char input[6]="v.dat";  		/* Voronoi Verticies */
    char input2[6]="r.dat";  	/* Verticies related to input */

    main_inp = fopen (input, "r");
    main_inp2 = fopen (input2, "r");

    char output[6]="a.dat";
    main_out= fopen (output,"w");

// Read in data, Calc Areas, Print out

    status = 1;
    fscanf(main_inp,"%d%d",&tempd,&nvert);
    for(i=0;i<nvert;i++)
        fscanf(main_inp,"%lf%lf",&x[i],&y[i]);
//  fscanf(main_inp2,"%d",&NTOT);
    for(i=0;i<NTOT;i++)
    {
	area=0;
	tempd=0;
        tempd2=0;
	fscanf(main_inp2,"%d",&nvert2[i]);
        for(j=0;j<nvert2[i];j++)
	{
	    fscanf(main_inp2,"%d",&vert[j]);
// Check for negative vericies
            if(vert[j]<0 )
		tempd++;
// Check for vericies greater than MAXD
//	    else if(fabs(x[vert[j]])> MAXD || fabs(y[vert[j]])>MAXD)
//		tempd2++;
	}
	if(tempd>0)
	{
	    m=0;
	    for(j=0;j<nvert2[i];j++)
	    {
		if(vert[j]>=0)
		{
		   vert[m]=vert[j];
		   m++;
		}
	    }
	    nvert2[i]=m;
	    j=m;
	}
        if(tempd2>0)
        {
            m=0;
            for(j=0;j<nvert2[i];j++)
            {
                if(!(fabs(x[vert[j]])> MAXD || fabs(y[vert[j]])>MAXD))
                {
                   vert[m]=vert[j];
                   m++;
                }
            }
            nvert2[i]=m;
            j=m;
        }


        vert[j]=vert[0];
        for(j=0;j<nvert2[i];j++)
	    area=area+0.5*(x[vert[j]]*y[vert[j+1]]-y[vert[j]]*x[vert[j+1]]);
	fprintf(main_out,"%1.4lf\t",fabs(area));
    }
    fprintf(main_out,"\n");
}
