#!/bin/csh 

# Obtain Voronoi Vertices 
/lustre/xzhuang/soybean/1_analyses/hybo-b1/mixture_areas/qhull-2003.1/qvoronoi Qt p < $1/xy.dat > $1/v.dat

# Obtain Vertices surrounding a Delaunay Point
/lustre/xzhuang/soybean/1_analyses/hybo-b1/mixture_areas/qhull-2003.1/qvoronoi Qt FN < $1/xy.dat > $1/r.dat

unset noclobber

# Only consider primary space atoms
head -$2 $1/r.dat > $1/r.old
mv -f $1/r.dat $1/copy.dat
tail -$3 $1/r.old > $1/r.dat

# Obtain the area for each atom
cd $1
area.exe

cat a.dat >> atomic-area.dat

